## qtmir 0.8.0~git20230115.30c2337

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(qtmir)

set(QTMIR_VERSION_MAJOR 0)
set(QTMIR_VERSION_MINOR 8)
set(QTMIR_VERSION_PATCH 0)

set(QTMIR_VERSION ${QTMIR_VERSION_MAJOR}.${QTMIR_VERSION_MINOR}.${QTMIR_VERSION_PATCH})

if(${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
   message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt and CMakeFiles/ from source root and try again.")
endif()

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package (ECM 1.7.0 QUIET NO_MODULE)
if (ECM_FOUND)
    # Provides us with -DECM_ENABLE_SANITIZERS='X'
    # Where X can be address, thread, memory, leak, undefined
    include("${ECM_MODULE_DIR}/ECMEnableSanitizers.cmake")
endif()

# add custom cmake modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Wall -Wextra")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -fno-strict-aliasing -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")

set (CMAKE_CXX_STANDARD 17)

if ("${CMAKE_CXX_COMPILER}" MATCHES "clang")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-return-type-c-linkage -Wno-mismatched-tags -Wno-inconsistent-missing-override -Wno-implicit-exception-spec-mismatch -Wno-unknown-pragmas")
endif()


#find_package(CoverageReport)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage (or ninja if you use that backend)
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
if(cmake_build_type_lower MATCHES coverage)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage" )
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage" )
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --coverage" )
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage" )
    ENABLE_COVERAGE_REPORT(TARGETS ${SHELL_APP} FILTER /usr/include ${CMAKE_SOURCE_DIR}/tests/* ${CMAKE_BINARY_DIR}/*)
endif()

# Make sure we have all the needed symbols
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,defs")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-z,defs")

# Static C++ checks
add_custom_target(cppcheck COMMAND cppcheck --enable=all -q --error-exitcode=2
                                       ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/tests)

option(WITH_CONTENTHUB "Build with content-hub" OFF)
option(WITH_VALGRIND "Build with Valgrind detection" ON)
option(WITH_MIR2 "Build with mir 2.x" OFF)

include(FindPkgConfig)
find_package(Qt5Core 5.9 REQUIRED)
find_package(Qt5DBus 5.9 REQUIRED)
find_package(Qt5Gui 5.9 REQUIRED)
find_package(Qt5Qml 5.9 REQUIRED)
find_package(Qt5Quick 5.9 REQUIRED)
find_package(Qt5Sensors 5.9 REQUIRED)
find_package(Qt5Test 5.9 REQUIRED)

find_package(Threads REQUIRED)

pkg_check_modules(MIRSERVER mirserver>=0.26 REQUIRED)
if(WITH_MIR2)
pkg_check_modules(MIROIL miroil REQUIRED)
else()
pkg_check_modules(MIRCLIENT mirclient>=0.26 REQUIRED)
endif()
pkg_check_modules(MIRRENDERERGLDEV mir-renderer-gl-dev>=0.26 REQUIRED)
pkg_check_modules(MIRAL miral>=1.1.0 REQUIRED)
pkg_check_modules(XKBCOMMON xkbcommon REQUIRED)
pkg_check_modules(GLIB glib-2.0 REQUIRED)
pkg_check_modules(PROCESS_CPP process-cpp REQUIRED)
pkg_check_modules(LOMIRI_APP_LAUNCH lomiri-app-launch-0 REQUIRED)
pkg_check_modules(URL_DISPATCHER lomiri-url-dispatcher REQUIRED)
pkg_check_modules(EGL egl)
pkg_check_modules(GIO gio-2.0)
pkg_check_modules(GIO_UNIX gio-unix-2.0)
pkg_check_modules(LTTNG lttng-ust)
pkg_check_modules(GSETTINGS_QT REQUIRED gsettings-qt)
pkg_check_modules(QTDBUSTEST libqtdbustest-1 REQUIRED)
pkg_check_modules(QTDBUSMOCK libqtdbusmock-1 REQUIRED)
pkg_check_modules(APPLICATION_API REQUIRED lomiri-shell-application=27)

if(WITH_VALGRIND)
    pkg_check_modules(VALGRIND valgrind REQUIRED)
    add_definitions(-DWITH_VALGRIND)
endif()

if(WITH_CONTENTHUB)
pkg_check_modules(CONTENT_HUB libcontent-hub>=0.2 REQUIRED)
message(STATUS "Bulding with content-hub")
endif()

include_directories(SYSTEM ${APPLICATION_API_INCLUDE_DIRS})

# Disable all deprecated qt functions in and before qt version 5.9
add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x050900)

# Use the fast string builder
add_definitions(-DQT_USE_QSTRINGBUILDER)

if (DEFINED USE_OPENGLES OR DEFINED USE_OPENGL_BUT_LINK_AGAINST_OPENGLES)
    message(DEPRECATION "USE_OPENGLES and USE_OPENGL_BUT_LINK_AGAINST_OPENGLES is no longer used as QtMir no longer links directly to libGL or libGLES.")
endif ()

# Standard install paths
include(GNUInstallDirs)


# Determine QPA plugin install path
# FIXME(greyback) there must be a better way than calling a private macro to set a property.
# I'm manually calling a macro from Qt5GuiConfig.cmake, but I don't understand why it isn't being called.
if (Qt5Gui_VERSION VERSION_LESS 5.14.0)
  _populate_Gui_plugin_properties("Gui" "PLATFORMS" "platforms")
else()
  _populate_Gui_plugin_properties("Gui" "PLATFORMS" "platforms" FALSE)
endif()
get_target_property(Qt5Gui_QPA_Plugin_Path Qt5::Gui IMPORTED_LOCATION_PLATFORMS)

# Set QML module install path
set(QML_MODULE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/qt5/qml")
set(QTMIR_DATA_DIR ${CMAKE_INSTALL_DATADIR}/qtmir)


# Customisations for the build type
if(NOT CMAKE_BUILD_TYPE)
    message(STATUS "Setting build type to 'RelWithDebInfo' as none was specified.")
    set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

if(cmake_build_type_lower MATCHES relwithdebinfo) # workaround for http://public.kitware.com/Bug/view.php?id=14696
    add_definitions(-DQT_NO_DEBUG)
endif()
if ("${CMAKE_BUILD_TYPE}" STREQUAL "release" OR "${CMAKE_BUILD_TYPE}" STREQUAL "relwithdebinfo")
    option(Werror "Treat warnings as errors" ON)
else()
    option(Werror "Treat warnings as errors" OFF)
endif()

if (Werror)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()


# Mir uses boost, which does not like Qt defining macros named "signals" and "slots"
add_definitions(-DQT_NO_KEYWORDS)

# Tests
if (NO_TESTS OR WITH_MIR2)
    message(STATUS "Tests disabled")
else()
    include(CTest)
    enable_testing()
    add_subdirectory(tests)
endif()

# add subdirectories to build
add_subdirectory(src)
add_subdirectory(demos)
add_subdirectory(benchmarks)
add_subdirectory(data)

=== data/CMakeLists.txt ===

install(FILES xwayland.qtmir.desktop
	DESTINATION ${CMAKE_INSTALL_DATADIR}/applications
)

install(FILES xwayland.qtmir.png
        DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/256x256/apps
)

=== src/platforms/mirserver/CMakeLists.txt ===
# Qt5PlatformSupport is not available as a cmake module.
# And also not anymore as pkgconfig module since Qt 5.6.
#pkg_check_modules(QT5PLATFORM_SUPPORT Qt5PlatformSupport REQUIRED)
include(FindQt5PlatformSupport)
include(UseLttngGenTp)

set(QTMIRSERVER_ABI 2)

set(qtmir_include ${CMAKE_SOURCE_DIR}/include)

if(NOT WITH_MIR2)
  set(MIROIL_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/miroil/include)
  add_subdirectory(miroil)
endif()

# Hacks for the QPA privates monster.
pkg_check_modules(FONTCONFIG fontconfig REQUIRED)

if (QGL_DEBUG)
    message(STATUS "Qt's OpenGL debug logging enabled.")
    add_definitions(-DQGL_DEBUG)
endif()

if (WITH_CONTENTHUB)
    add_definitions(-DWITH_CONTENTHUB)
endif()

#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c11 -fPIC")

find_package(Qt5FontDatabaseSupport REQUIRED)
find_package(Qt5ThemeSupport REQUIRED)
find_package(Qt5EventDispatcherSupport REQUIRED)
find_package(Qt5EglSupport REQUIRED)
find_package(Qt5ServiceSupport REQUIRED)
set(QT5PLATFORMSUPPORT_LIBS
    Qt5FontDatabaseSupport::Qt5FontDatabaseSupport
    Qt5ThemeSupport::Qt5ThemeSupport
    Qt5EventDispatcherSupport::Qt5EventDispatcherSupport
    Qt5EglSupport::Qt5EglSupport
    Qt5ServiceSupport::Qt5ServiceSupport
)

include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/src/common
    ${CMAKE_CURRENT_BINARY_DIR} # for tracepoints.h
)

include_directories(
    SYSTEM
    ${MIRAL_INCLUDE_DIRS}
    ${MIRCOMMON_INCLUDE_DIRS}
    ${MIRSERVER_INCLUDE_DIRS}
    ${MIRRENDERERGLDEV_INCLUDE_DIRS}
    ${MIRSERVER_INCLUDE_DIRS}
    ${MIROIL_INCLUDE_DIRS}

    ${URL_DISPATCHER_INCLUDE_DIRS}
    ${EGL_INCLUDE_DIRS}
    ${LTTNG_INCLUDE_DIRS}

    ${Qt5Gui_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}


    ${Qt5Quick_INCLUDE_DIRS}
    ${Qt5Quick_PRIVATE_INCLUDE_DIRS}
    ${Qt5Qml_INCLUDE_DIRS}

    ${APPLICATION_API_INCLUDE_DIRS}

if(WITH_CONTENTHUB)
    ${CONTENT_HUB_INCLUDE_DIRS}
endif()

    ${VALGRIND_INCLUDE_DIRS}
)

# We have to remove -pedantic for tracepoints.c
string (REPLACE " -pedantic " " " TRACEPOINTS_CMAKE_C_FLAGS ${CMAKE_C_FLAGS})
# BYTE_ORDER needed to compile tracepoints in C99 mode.
set(TRACEPOINTS_CMAKE_C_FLAGS "${TRACEPOINTS_CMAKE_C_FLAGS} -DBYTE_ORDER=__BYTE_ORDER -fPIC ")
set_source_files_properties(tracepoints.c PROPERTIES COMPILE_FLAGS "${TRACEPOINTS_CMAKE_C_FLAGS}")

# Generate tracepoints.c and .h from tracepoints.tp
add_lttng_gen_tp(NAME tracepoints)
add_custom_target(MirServer_LTTNG
    DEPENDS tracepoints.h tracepoints.c
)

if(WITH_CONTENTHUB)
    set(CLIPBOARD_SRC clipboard.cpp)
endif()

# These files will compile without mirserver-dev
add_library(qtmirserver-nomirserver OBJECT
    ${CMAKE_SOURCE_DIR}/src/common/timestamp.cpp
    ${CLIPBOARD_SRC}
    logging.cpp
    shelluuid.cpp
    mirsingleton.cpp
    wrappedsessionauthorizer.cpp
    promptsessionlistener.cpp
    displayconfigurationstorage.cpp
    nativeinterface.cpp
    services.cpp
    windowcontroller.cpp
    workspacecontroller.cpp
    tracepoints.c
    surfaceobserver.cpp
    initialsurfacesizes.cpp
    orientationsensor.cpp
    screenadaptor.cpp
    screenadaptormodel.cpp
    qtmir.cpp
)
add_dependencies(qtmirserver-nomirserver MirServer_LTTNG)

include_directories(SYSTEM ${MIRSERVER_INCLUDE_DIRS})

# These files will only compile with mirserver-dev
add_library(qtmirserver-mirserver OBJECT
    screenscontroller.cpp
    qtcompositor.cpp
    displayconfigurationpolicy.cpp
    wrappedwindowmanagementpolicy.cpp
 #   mirdisplayconfigurationobserver.cpp
)
add_dependencies(qtmirserver-mirserver MirServer_LTTNG)

# These files get entangled by automoc so they need to go together. And some depend on mirserver-dev
set(QMIRSERVER_PLUGIN_SRC
    ${CMAKE_SOURCE_DIR}/src/common/debughelpers.cpp
    cursor.cpp
    eventbuilder.cpp
    qteventfeeder.cpp
    qmirserver.cpp
    qmirserver_p.cpp
    platformscreen.cpp
    screenplatformwindow.cpp
    screensmodel.cpp
    miropenglcontext.cpp
    offscreensurface.cpp
    inputdeviceobserver.cpp
    mirserverapplication.cpp
    windowmodelnotifier.cpp

# We need to run moc on these headers
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/MirMousePointerInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/Mir.h

    ${CMAKE_SOURCE_DIR}/include/qtmir/mirserverapplication.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/displayconfigurationpolicy.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/sessionauthorizer.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/windowmanagementpolicy.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/displayconfigurationstorage.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/screen.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/screens.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/types.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/qtmir.h

    ${CMAKE_SOURCE_DIR}/src/common/windowcontrollerinterface.h
    ${CMAKE_SOURCE_DIR}/src/common/workspacecontrollerinterface.h
    ${CMAKE_SOURCE_DIR}/src/common/windowmodelnotifier.h
    ${CMAKE_SOURCE_DIR}/src/common/appnotifier.h
)

if(NOT WITH_MIR2)
  set(MIROIL_OBJ $<TARGET_OBJECTS:miroil>)
endif()

add_library(qtmirserver SHARED
    ${QMIRSERVER_PLUGIN_SRC}
    $<TARGET_OBJECTS:qtmirserver-nomirserver>
    $<TARGET_OBJECTS:qtmirserver-mirserver>
    ${MIROIL_OBJ}
)

target_link_libraries(qtmirserver
    PUBLIC
        ${MIRAL_LDFLAGS}
        ${MIROIL_LDFLAGS}
        ${MIROIL_LIBRARIES}
        ${MIRSERVER_LDFLAGS}
        Qt5::Core
        Qt5::Gui

    PRIVATE
        Threads::Threads
        ${URL_DISPATCHER_LDFLAGS}
        ${EGL_LDFLAGS}
        ${LTTNG_LIBRARIES}
        ${GIO_LDFLAGS}
        ${FONTCONFIG_LDFLAGS}
        ${XKBCOMMON_LIBRARIES}

        ${CONTENT_HUB_LIBRARIES}

        Qt5::DBus
        Qt5::Quick
        Qt5::Sensors
        ${QT5PLATFORMSUPPORT_LIBS}
)

set_target_properties(qtmirserver
  PROPERTIES
  SOVERSION ${QTMIRSERVER_ABI}
)

set(LIBDIR "${CMAKE_INSTALL_FULL_LIBDIR}")
set(INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include/qtmir")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qtmirserver.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/qtmirserver.pc
    @ONLY
)

install(
  TARGETS qtmirserver
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(
  DIRECTORY ${CMAKE_SOURCE_DIR}/include/qtmir
  DESTINATION "include/qtmir"
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/qtmirserver.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

if(NOT WITH_MIR2)
  # To avoid conflicts, we install to qtmir include
  # and since do -I/some/thing/qtmir in the .pc we can
  # include miroil as <miroil/blah>
  install(
    DIRECTORY ${CMAKE_SOURCE_DIR}/include/miroil
    DESTINATION "include/qtmir"
  )
endif()

add_library(qpa-mirserver SHARED
    mirserverintegration.cpp
    plugin.cpp
)

target_link_libraries(qpa-mirserver
PRIVATE
    qtmirserver
    ${QT5PLATFORMSUPPORT_LIBS}

    ${MIRSERVER_LDFLAGS}
    ${URL_DISPATCHER_LDFLAGS}
    ${EGL_LDFLAGS}
    ${LTTNG_LIBRARIES}
    ${GIO_LDFLAGS}
    ${FONTCONFIG_LDFLAGS}
    ${XKBCOMMON_LIBRARIES}

    ${CONTENT_HUB_LIBRARIES}

    Qt5::Core
    Qt5::DBus
    Qt5::Quick
    Qt5::Sensors
    Qt5::Qml
)

install(TARGETS qpa-mirserver LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}/qt5/plugins/platforms")

=== debian/changelog ===
qtmir (0.8.0~git20230115.30c2337-3) unstable; urgency=medium

  * debian/.install: Spesify that we only want xwayland desktop & icon
    file in qml-module-qtmir (closes: #1029291)

 -- Marius Gripsgard <marius@ubports.com>  Sun, 22 Jan 2023 05:54:37 +0000

qtmir (0.8.0~git20230115.30c2337-2) unstable; urgency=medium

  * debian/control: Drop mir-pref-framework from qtmir-tests (closes: #1029015)

 -- Marius Gripsgard <marius@ubports.com>  Tue, 17 Jan 2023 22:18:34 +0000

qtmir (0.8.0~git20230115.30c2337-1) unstable; urgency=medium

  * New git snapshot (0.8.0~git20230115.30c2337)
  * debian/*.symbols: Refresh symbols using pkgkde
  * debian/patches: Refresh patch to match new git snapshot
  * debian/copyright: Refresh copyright to match new git snapshot
  * debian/.install: Install x11 desktop file and icon

 -- Marius Gripsgard <marius@ubports.com>  Sun, 15 Jan 2023 20:23:41 +0100

qtmir (0.8.0~git20230109.671f617-3) unstable; urgency=medium

  * Now!!! Really re-upload as is to unstable.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 13 Jan 2023 16:45:56 +0100

qtmir (0.8.0~git20230109.671f617-2) experimental; urgency=medium

  * Re-upload as is to unstable.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 13 Jan 2023 13:23:18 +0100

qtmir (0.8.0~git20230109.671f617-1) experimental; urgency=medium

  * Upload to experimental.

  [ Marius Gripsgard ]
  * New git snapshot (based on ubports/focal_-_mir2 branch)
  * debian/*:
    + Bump libqtmirserver soname version to 2
  * debian/control:
    + Bump mir requirement to 2.11 and add miroil-dev as B-D.
  * debian/rules:
    + Build with MIR2 option enabled.
  * debian/watch:
    + Update watch to pull git branch.
  * debian/copyright:
    + Refresh copyright to match new git snapshot
  * debian/*.symbols:
    + Refresh symbols using pkgkde.

  [ Mike Gabriel ]
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update attributions for debian/.
  * debian/changelog:
    + Amend white-space issue.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 10 Jan 2023 08:07:55 +0100

qtmir (0.7.1-3) unstable; urgency=medium

  * [debian/.symbols] Refresh symbols using pkgkde

 -- Marius Gripsgard <marius@ubports.com>  Tue, 03 Jan 2023 10:38:41 +0100

qtmir (0.7.1-2) unstable; urgency=medium

  * debian/rules:
    - Disable valgrind on mipsel due to known issues with valgrind on mipsel

 -- Marius Gripsgard <marius@ubports.com>  Mon, 02 Jan 2023 12:04:30 +0100

qtmir (0.7.1-1) unstable; urgency=medium

  * New upstream release v0.7.1
  * Drop upstreamed patch:
    - 0001_remove-unused-gmock-fixes.patch
  * Refresh libqtmirserver1 symbols using pkgkde
  * Update copyright to match new upstream release v0.7.1

 -- Marius Gripsgard <marius@ubports.com>  Mon, 02 Jan 2023 03:25:08 +0100

qtmir (0.7.0-4) unstable; urgency=medium

  * debian/libqtmirserver1.symbols:
    + Update symbols. (Closes: #1021359).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 07 Oct 2022 09:20:06 +0200

qtmir (0.7.0-3) unstable; urgency=medium

  * debian/patches:
    + Cherry-picḱ 0001_remove-unused-gmock-fixes.patch. (Closes: #1015133).
  * debian/:
    + Update upstream Git repo URL.
  * debian/control:
    + Bump Standards-Version: to 4.6.1. No changes needed.
  * debian/libqtmirserver1.symbols:
    + Update .symbols for gcc-12 rebuild.
  * debian/copyright:
    + Update copyright attributions for debian/*.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 05 Oct 2022 21:03:05 +0200

=== debian/control ===
Source: qtmir
Section: libs
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>,
 Mike Gabriel <sunweaver@debian.org>,
 Marius Gripsgard <marius@ubports.com>,
Build-Depends: cmake,
               cmake-extras (>= 1.6~),
               debhelper-compat (= 13),
               googletest (>= 1.10.0),
               libfontconfig1-dev,
               libgles2-mesa-dev,
               libglib2.0-dev,
               libgsettings-qt-dev,
               libgtest-dev,
               liblttng-ust-dev,
               libmiral-dev (>= 3.0),
               libmircommon-dev (>= 2.11.0),
               libmirserver-dev (>= 2.11.0),
               libmtdev-dev,
               libprocess-cpp-dev,
               libqt5sensors5-dev,
               libqtdbusmock1-dev (>= 0.2),
               libqtdbustest1-dev (>= 0.2),
               liblomiri-app-launch-dev,
               libudev-dev,
               liblomiri-api-dev (>= 0.1.1),
               liblomiri-url-dispatcher-dev,
               libxkbcommon-dev,
               libxrender-dev,
               mir-renderer-gl-dev (>= 2.11.0),
               mirtest-dev (>= 2.11.0),
               libmiroil-dev,
               pkg-config,
               pkg-kde-tools,
# lttng-gen-ts needs python3, but doesn't depend on it itself: bug 1359147
               python3:any,
               qtbase5-dev,
               qtbase5-private-dev,
               qtdeclarative5-dev,
               qtdeclarative5-private-dev,
               quilt,
               valgrind-if-available,
# libmirserver-dev should have brought this dep. Bug lp:1617435
               uuid-dev,
# mirtest pkgconfig requires these, but doesn't have a deb dependency. Bug lp:1633537
               libboost-filesystem-dev,
               libboost-system-dev,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/qtmir
Vcs-Git: https://salsa.debian.org/ubports-team/qtmir.git
Vcs-Browser: https://salsa.debian.org/ubports-team/qtmir

Package: qtmir
Architecture: linux-any
Multi-Arch: same
Breaks: qtmir-android (<< 0.7.0~),
        qtmir-desktop (<< 0.7.0~),
Replaces: qtmir-android (<< 0.7.0~),
          qtmir-desktop (<< 0.7.0~),
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Qt platform abstraction (QPA) plugin for a Mir server
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.

Package: qtmir-android
Architecture: armhf arm64
Multi-Arch: same
Depends: qtmir, ${misc:Depends},
Section: oldlibs
Description: QPA plugin for a Mir server (mobile, transitional package)
  QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
  It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
  a Mir server. It also exposes some internal Mir functionality.
 .
 This variant of the package is for Android-based phones and tablets.
 .
 This is a transitional package. It can safely be removed.

Package: qtmir-desktop
Architecture: linux-any
Multi-Arch: same
Depends: qtmir, ${misc:Depends},
Section: oldlibs
Description: QPA plugin for a Mir server (desktop, transitional package)
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 This variant of the package is for GNU-based desktops.
 .
 This is a transitional package. It can safely be removed.

Package: libqtmirserver-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: qtmir (= ${binary:Version}),
         ${misc:Depends},
         libmiral-dev (>= 3.0),
         libmiroil-dev,
Description: Developer files for QtMir server API
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 This package contains the library headers for developers.

Package: libqtmirserver2
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
      ${shlibs:Depends},
Description: QtMir server API shared library
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 Contains the shared library containing QtMir server API.

Package: qml-module-qtmir
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: qtmir (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Provides: lomiri-application-impl,
          lomiri-application-impl-27,
Description: Qt/QML module for Lomiri specific Mir APIs
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 QtMir provides Qt/QML bindings for Mir features that are exposed through the
 qtmir QPA plugin such as Application management (start/stop/suspend/resume)
 and surface management.

Package: qtmir-tests
Section: libdevel
Architecture: linux-any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends},
Depends: littler,
         lttng-tools,
         mir-test-tools,
         qml-module-lomiri-components,
         qml-module-qtmir,
         qtmir (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: QtMir tests and demos
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 This package provides benchmark tests and a simple shell and client using the
 QtMir QPA.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to be more picky with non-updated .symbols files
#export DPKG_GENSYMBOLS_CHECK_LEVEL=4

include /usr/share/dpkg/default.mk

include /usr/share/dpkg/buildflags.mk
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_missing:
	dh_missing --fail-missing

FLAGS := -DWerror=OFF -DWITH_MIR2=on
# Explicitly disable building with Valgrind on architectures without it.
valgrind_architectures := amd64 arm64 armhf i386 mips64el ppc64el s390x powerpc ppc64 x32
ifeq ($(filter $(DEB_HOST_ARCH), $(valgrind_architectures)),)
	FLAGS += -DWITH_VALGRIND=OFF
endif

override_dh_auto_configure:
	dh_auto_configure -- $(FLAGS)

override_dh_install:
	#clean gmock/gtest if it built in our build dir
	-rm -f debian/tmp/usr/lib/libgmock*.a debian/tmp/usr/lib/libgtest*.a
	-rm -rf debian/tmp/usr/include/gmock debian/tmp/usr/include/gtest
	dh_install

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

## qtmir 0.8.0~git20230223.bd21224

=== CMakeLists.txt ===
--- 
+++ 
@@ -87,6 +87,10 @@
 endif()
 pkg_check_modules(MIRRENDERERGLDEV mir-renderer-gl-dev>=0.26 REQUIRED)
 pkg_check_modules(MIRAL miral>=1.1.0 REQUIRED)
+pkg_check_modules(MIRWAYLAND mirwayland REQUIRED)
+pkg_check_modules(WAYLAND_CLIENT REQUIRED wayland-client)
+pkg_check_modules(WAYLAND_SERVER REQUIRED wayland-server)
+
 pkg_check_modules(XKBCOMMON xkbcommon REQUIRED)
 pkg_check_modules(GLIB glib-2.0 REQUIRED)
 pkg_check_modules(PROCESS_CPP process-cpp REQUIRED)
@@ -99,7 +103,7 @@
 pkg_check_modules(GSETTINGS_QT REQUIRED gsettings-qt)
 pkg_check_modules(QTDBUSTEST libqtdbustest-1 REQUIRED)
 pkg_check_modules(QTDBUSMOCK libqtdbusmock-1 REQUIRED)
-pkg_check_modules(APPLICATION_API REQUIRED lomiri-shell-application=27)
+pkg_check_modules(APPLICATION_API REQUIRED lomiri-shell-application=28)
 
 if(WITH_VALGRIND)
     pkg_check_modules(VALGRIND valgrind REQUIRED)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,3 @@
-
 install(FILES xwayland.qtmir.desktop
 	DESTINATION ${CMAKE_INSTALL_DATADIR}/applications
 )

=== demos/CMakeLists.txt ===
configure_file(paths.h.in ${CMAKE_CURRENT_BINARY_DIR}/paths.h @ONLY)

add_subdirectory(qtmir-demo-client)
add_subdirectory(qtmir-demo-shell)

=== src/modules/QtMir/Application/CMakeLists.txt ===
include(UseLttngGenTp)

if(NOT WITH_MIR2)
 set(MIROIL_INC ${CMAKE_SOURCE_DIR}/src/platforms/mirserver/miroil/include)
endif()

include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/src/platforms/mirserver
    ${MIROIL_INC}
    ${CMAKE_SOURCE_DIR}/src/common
    ${CMAKE_CURRENT_BINARY_DIR} # for tracepoints.h
)

include_directories(
    SYSTEM
    ${GLIB_INCLUDE_DIRS}
    ${GIO_INCLUDE_DIRS}
    ${GIO_UNIX_INCLUDE_DIRS}
    ${MIRAL_INCLUDE_DIRS}
    ${MIRSERVER_INCLUDE_DIRS}
    ${MIROIL_INCLUDE_DIRS}
    ${MIRRENDERERGLDEV_INCLUDE_DIRS}
    ${PROCESS_CPP_INCLUDE_DIRS}
    ${UBUNTU_PLATFORM_API_INCLUDE_DIRS}
    ${LOMIRI_APP_LAUNCH_INCLUDE_DIRS}
    ${GSETTINGS_QT_INCLUDE_DIRS}

    ${LTTNG_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Qml_PRIVATE_INCLUDE_DIRS}
    ${Qt5Quick_PRIVATE_INCLUDE_DIRS}
)

# We have to remove -pedantic in order to compile tracepoints.c
string (REPLACE " -pedantic " " " CMAKE_C_FLAGS ${CMAKE_C_FLAGS})
# Needed to compile tracepoints in C99 mode.
add_definitions(-DBYTE_ORDER=__BYTE_ORDER)

# Generate tracepoints.c and .h from tracepoints.tp
add_lttng_gen_tp(NAME tracepoints)
add_custom_target(QtMirApplication_LTTNG
    DEPENDS tracepoints.h tracepoints.c
)

set(QMLMIRPLUGIN_SRC
    application_manager.cpp
    application.cpp
    compositortextureprovider.cpp
    ../../../common/abstractdbusservicemonitor.cpp
    ../../../common/debughelpers.cpp
    dbusfocusinfo.cpp
    plugin.cpp
    mirsurface.cpp
    mirsurfaceinterface.h
    mirsurfaceitem.cpp
    mirsurfacelistmodel.cpp
    mirbuffersgtexture.cpp
    proc_info.cpp
    session.cpp
    sharedwakelock.cpp
    surfacemanager.cpp
    taskcontroller.cpp
    upstart/applicationinfo.cpp
    upstart/taskcontroller.cpp
    timer.cpp
    timesource.cpp
    tracepoints.c
    settings.cpp
    windowmodel.cpp
# We need to run moc on these headers
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/ApplicationInfoInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/ApplicationManagerInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/Mir.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/MirSurfaceInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/MirSurfaceItemInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/MirSurfaceListInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/SurfaceManagerInterface.h
# Feed the automoc monster
    session_interface.h
    applicationinfo.h
    taskcontroller.h
    settings_interface.h
)

add_library(qtmirapplicationplugin SHARED
    ${QMLMIRPLUGIN_SRC}
)
add_dependencies(qtmirapplicationplugin QtMirApplication_LTTNG)

# Frig for files that still rely on mirserver-dev
string(REPLACE ";" " -I" QTMIR_ADD_MIRSERVER "-I ${MIRSERVER_INCLUDE_DIRS}")
set_source_files_properties(mirsurface.cpp         PROPERTIES COMPILE_FLAGS "${CMAKE_CXXFLAGS} ${QTMIR_ADD_MIRSERVER}")

target_link_libraries(
    qtmirapplicationplugin

    ${CMAKE_THREAD_LIBS_INIT}

    ${GLIB_LDFLAGS}
    ${UBUNTU_PLATFORM_API_LDFLAGS}
    ${MIRSERVER_LDFLAGS}
    ${PROCESS_CPP_LDFLAGS}
    ${LOMIRI_APP_LAUNCH_LDFLAGS}
    ${LTTNG_LDFLAGS}
    ${GSETTINGS_QT_LDFLAGS}

    Qt5::Core
    Qt5::DBus
    Qt5::Qml
    Qt5::Quick

    qtmirserver
)


# install
add_qml_plugin(QtMir.Application 0.1 QtMir/Application TARGETS qtmirapplicationplugin)
install(FILES com.canonical.qtmir.gschema.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/glib-2.0/schemas)

=== src/platforms/mirserver/miroil/src/CMakeLists.txt ===
add_library(miroil OBJECT
    compositor.cpp ${MIROIL_INCLUDE_DIRS}/miroil/compositor.h
    edid.cpp ${qtmir_include}/miroil/edid.h
    mirbuffer.cpp ${MIROIL_INCLUDE_DIRS}/miroil/mirbuffer.h
    persist_display_config.cpp ${MIROIL_INCLUDE_DIRS}/miroil/persist_display_config.h
    display_configuration_policy.cpp ${qtmir_include}/miroil/display_configuration_policy.h
    display_configuration_controller_wrapper.cpp ${MIROIL_INCLUDE_DIRS}/miroil/display_configuration_controller_wrapper.h
    display_listener_wrapper.cpp ${MIROIL_INCLUDE_DIRS}/miroil/display_listener_wrapper.h
    eventdispatch.cpp ${MIROIL_INCLUDE_DIRS}/miroil/eventdispatch.h
    event_builder.cpp ${MIROIL_INCLUDE_DIRS}/miroil/event_builder.h
    input_device.cpp ${MIROIL_INCLUDE_DIRS}/miroil/input_device.h
    input_device_observer.cpp ${MIROIL_INCLUDE_DIRS}/miroil/input_device_observer.h
    mir_server_hooks.cpp ${MIROIL_INCLUDE_DIRS}/miroil/mir_server_hooks.h
    mir_prompt_session.cpp ${MIROIL_INCLUDE_DIRS}/miroil/mir_prompt_session.h
    open_gl_context.cpp ${MIROIL_INCLUDE_DIRS}/miroil/open_gl_context.h
    prompt_session_listener.cpp ${MIROIL_INCLUDE_DIRS}/miroil/prompt_session_listener.h
    prompt_session_manager.cpp ${MIROIL_INCLUDE_DIRS}/miroil/prompt_session_manager.h
    set_compositor.cpp ${MIROIL_INCLUDE_DIRS}/miroil/set_compositor.h
    surface.cpp ${MIROIL_INCLUDE_DIRS}/miroil/surface.h
    ${qtmir_include}/miroil/display_configuration_storage.h
    ${qtmir_include}/miroil/display_id.h
)

target_include_directories(miroil
    PUBLIC  "${MIROIL_INCLUDE_DIRS}" "${qtmir_include}" "${qtmir_include}/qtmir"
    PRIVATE ${MIRAL_INCLUDE_DIRS}
    ${MIRCOMMON_INCLUDE_DIRS}
    ${MIRSERVER_INCLUDE_DIRS}
    ${MIRRENDERERGLDEV_INCLUDE_DIRS}
    ${MIRSERVER_INCLUDE_DIRS}
)

target_link_libraries(miroil
    PRIVATE
    ${MIRAL_LDFLAGS}
    ${MIRSERVER_LDFLAGS}

    ${EGL_LDFLAGS}
)

=== debian/changelog ===
qtmir (0.8.0~git20230223.bd21224-3) unstable; urgency=medium

  * debian/patches:
    + Add 1003_require-miroil-in-pkgconfig-file.patch. Require miroil in out .pc
      file. Resolved FTBFS in lomiri.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 26 Feb 2023 22:35:52 +0100

qtmir (0.8.0~git20230223.bd21224-2) unstable; urgency=medium

  * debian/libqtmirserver2.symbols:
    + Update symbols using pkgkde-symbolshelper. (Closes: #1031961).

 -- Mike Gabriel <mike.gabriel@das-netzwerkteam.de>  Sun, 26 Feb 2023 14:57:35 +0100

qtmir (0.8.0~git20230223.bd21224-1) unstable; urgency=medium

  * New upstream Git snapshot.
    - Fix crash when unplugging a USB keyboard device.
    - Fix crash when switching from tty7 to tty1..tty6.
    - Fix scaled buffers crashing (i.e. fix HiDPI support).
  * debian/libqtmirserver2.symbols:
    + Update symbols.
  * debian/patches:
    + Add 1002_maliit-keyboard. Always tag maliit-server as
      mir_windowtype_inputmethod.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 23 Feb 2023 21:11:10 +0100

qtmir (0.8.0~git20230215.2ba9390-1) unstable; urgency=medium

  * New upstream Git snapshot.
  * debian/control:
    + Add to B-D: libmirwayland-dev.
    + Add version to B-D: libmirwayland-dev (>= 2.12.0+dfsg-3~). Versions before
      don't pull in libwayland-dev.
  * debian/patches:
    + Trivial rebase of 2003_disable-benchmarks.patch.
    + Add 1001_copyright-header-cleanup.patch. Use uniform spelling of
      copyright holders.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 17 Feb 2023 11:08:00 +0100

qtmir (0.8.0~git20230207.ec35994-1) unstable; urgency=medium

  [ Mike Gabriel ]
  * debian/rules:
    + Don't hard-code architectures with valgrind support. Simply disable
      valgrind if not found in $PATH. (Closes: #1022222).
  * debian/control:
    + Bump to versioned B-D on liblomiri-api-dev (>= 0.2.0).

  [ Marius Gripsgard ]
  * New upstream Git snapshot.
    - Bump lomiri-application-shell API compat level to 28. (Closes: #1030460).

 -- Marius Gripsgard <marius@ubports.com>  Wed, 08 Feb 2023 00:44:49 +0100

=== debian/control ===
--- 
+++ 
@@ -26,13 +26,14 @@
                libqtdbustest1-dev (>= 0.2),
                liblomiri-app-launch-dev,
                libudev-dev,
-               liblomiri-api-dev (>= 0.1.1),
+               liblomiri-api-dev (>= 0.2.0),
                liblomiri-url-dispatcher-dev,
                libxkbcommon-dev,
                libxrender-dev,
                mir-renderer-gl-dev (>= 2.11.0),
                mirtest-dev (>= 2.11.0),
                libmiroil-dev,
+               libmirwayland-dev (>= 2.12.0+dfsg-3~),
                pkg-config,
                pkg-kde-tools,
 # lttng-gen-ts needs python3, but doesn't depend on it itself: bug 1359147

=== debian/rules ===
--- 
+++ 
@@ -19,9 +19,11 @@
 	dh_missing --fail-missing
 
 FLAGS := -DWerror=OFF -DWITH_MIR2=on
+
 # Explicitly disable building with Valgrind on architectures without it.
-valgrind_architectures := amd64 arm64 armhf i386 mips64el ppc64el s390x powerpc ppc64 x32
-ifeq ($(filter $(DEB_HOST_ARCH), $(valgrind_architectures)),)
+# If valgrind is available or not gets decided via the valgrind-if-available
+# virtual package.
+ifeq (, $(shell command -v valgrind))
 	FLAGS += -DWITH_VALGRIND=OFF
 endif

## qtmir 0.8.0~git20230628.b7803c8

=== debian/changelog ===
qtmir (0.8.0~git20230628.b7803c8-1) unstable; urgency=medium

  * New upstream git snapshot
  * debian/watch: Switch to desktop development branch
  * debian/symbols: Disable symbols for now as we are using git snapshots
    (closes: #1037829)
  * debian/control: Use my new debian email

 -- Marius Gripsgard <mariogrip@debian.org>  Thu, 27 Jul 2023 20:53:23 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>,
  Mike Gabriel <sunweaver@debian.org>,
- Marius Gripsgard <marius@ubports.com>,
+ Marius Gripsgard <mariogrip@debian.org>,
 Build-Depends: cmake,
                cmake-extras (>= 1.6~),
                debhelper-compat (= 13),

## qtmir 0.8.0~git20240131.2f99df3

=== CMakeLists.txt ===
--- 
+++ 
@@ -111,7 +111,7 @@
 endif()
 
 if(WITH_CONTENTHUB)
-pkg_check_modules(CONTENT_HUB libcontent-hub>=0.2 REQUIRED)
+pkg_check_modules(CONTENT_HUB libcontent-hub>=1.0.0 REQUIRED)
 message(STATUS "Bulding with content-hub")
 endif()

=== src/platforms/CMakeLists.txt ===
add_subdirectory(mirserver)

=== tests/modules/CMakeLists.txt ===
add_subdirectory(Application)
add_subdirectory(ApplicationManager)
add_subdirectory(General)
add_subdirectory(Session)
add_subdirectory(SharedWakelock)
add_subdirectory(SurfaceManager)
add_subdirectory(WindowManager)

=== src/platforms/mirserver/CMakeLists.txt ===
--- 
+++ 
@@ -12,6 +12,8 @@
   set(MIROIL_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/miroil/include)
   add_subdirectory(miroil)
 endif()
+
+add_subdirectory(wayland-generated)
 
 # Hacks for the QPA privates monster.
 pkg_check_modules(FONTCONFIG fontconfig REQUIRED)
@@ -46,6 +48,9 @@
     ${CMAKE_CURRENT_BINARY_DIR} # for tracepoints.h
 )
 
+set(MIRCOMMON_INCLUDE_DIRS /usr/include/mircommon/)
+set(MIRCOMMON_LDFLAGS "-lmircommon")
+
 include_directories(
     SYSTEM
     ${MIRAL_INCLUDE_DIRS}
@@ -54,6 +59,7 @@
     ${MIRRENDERERGLDEV_INCLUDE_DIRS}
     ${MIRSERVER_INCLUDE_DIRS}
     ${MIROIL_INCLUDE_DIRS}
+    ${MIRWAYLAND_INCLUDE_DIRS}
 
     ${URL_DISPATCHER_INCLUDE_DIRS}
     ${EGL_INCLUDE_DIRS}
@@ -104,6 +110,7 @@
     displayconfigurationstorage.cpp
     nativeinterface.cpp
     services.cpp
+    urlbuilderdispatcher.cpp
     windowcontroller.cpp
     workspacecontroller.cpp
     tracepoints.c
@@ -125,6 +132,9 @@
     displayconfigurationpolicy.cpp
     wrappedwindowmanagementpolicy.cpp
  #   mirdisplayconfigurationobserver.cpp
+    wayland-generated/qt-windowmanager_wrapper.cpp
+    wayland-generated/xdg-decoration-unstable-v1_wrapper.cpp
+    wayland-generated/server-decoration_wrapper.cpp
 )
 add_dependencies(qtmirserver-mirserver MirServer_LTTNG)
 
@@ -133,6 +143,7 @@
     ${CMAKE_SOURCE_DIR}/src/common/debughelpers.cpp
     cursor.cpp
     eventbuilder.cpp
+    qtwindowmanager.cpp
     qteventfeeder.cpp
     qmirserver.cpp
     qmirserver_p.cpp
@@ -145,6 +156,9 @@
     mirserverapplication.cpp
     windowmodelnotifier.cpp
 
+    wayland/xdgdecorationV1.cpp
+    wayland/kwinserverdecoration.cpp
+
 # We need to run moc on these headers
     ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/MirMousePointerInterface.h
     ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/Mir.h
@@ -194,6 +208,11 @@
         ${FONTCONFIG_LDFLAGS}
         ${XKBCOMMON_LIBRARIES}
 
+        ${MIRCOMMON_LDFLAGS}
+        ${MIRWAYLAND_LDFLAGS}
+        ${WAYLAND_CLIENT_LIBRARIES}
+        ${WAYLAND_SERVER_LDFLAGS}
+
         ${CONTENT_HUB_LIBRARIES}
 
         Qt5::DBus

=== tests/mirserver/QtEventFeeder/CMakeLists.txt ===
set(
  EVENT_FEEDER_TEST_SOURCES
  qteventfeeder_test.cpp
  mock_qtwindowsystem.h
  ${CMAKE_SOURCE_DIR}/src/common/debughelpers.cpp
)

include_directories(
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver
  ${CMAKE_SOURCE_DIR}/src/common
)

include_directories(
  SYSTEM
  ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
  ${MIRSERVER_INCLUDE_DIRS}
)

add_executable(QtEventFeederTest ${EVENT_FEEDER_TEST_SOURCES})

target_link_libraries(
  QtEventFeederTest
  -pthread
  qtmirserver
  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARIES}
)

add_test(QtEventFeeder, QtEventFeederTest)

=== tests/mirserver/ScreensModel/CMakeLists.txt ===
set(
  SCREENCONTROLLER_TEST_SOURCES
  screensmodel_test.cpp
  ${CMAKE_SOURCE_DIR}/src/common/debughelpers.cpp
  # to be moc-ed
  stub_screen.h
  testable_screensmodel.h
)

include_directories(
  ${CMAKE_SOURCE_DIR}/include
  ${CMAKE_SOURCE_DIR}/tests/framework
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver/miroil/include
  ${CMAKE_SOURCE_DIR}/src/common
)

include_directories(
  SYSTEM
  ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
  ${MIROIL_INCLUDE_DIRS}
  ${MIRSERVER_INCLUDE_DIRS}
  ${MIRRENDERERGLDEV_INCLUDE_DIRS}
  ${MIRTEST_INCLUDE_DIRS}
)

add_executable(ScreensModelTest ${SCREENCONTROLLER_TEST_SOURCES})

set_property(TARGET ScreensModelTest PROPERTY CXX_STANDARD 14)

target_link_libraries(
  ScreensModelTest
  qtmirserver

  -L${CMAKE_BINARY_DIR}/tests/framework
  qtmir-test-framework-static

  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARIES}
)

add_test(ScreensModel, ScreensModelTest)

=== tests/mirserver/miral/CMakeLists.txt ===
set(
  MIRAL_TEST_SOURCES
  edid_test.cpp
)

include_directories(
  ${CMAKE_SOURCE_DIR}/include
  ${MIROIL_INCLUDE_DIRS}
)

add_executable(MirALTests ${MIRAL_TEST_SOURCES})

target_link_libraries(MirALTests
  qtmirserver
  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARIES}
  ${MIROIL_LDFLAGS}
)

add_test(MirAL, MirALTests)

=== tests/modules/SurfaceManager/CMakeLists.txt ===
set(
  SURFACE_MANAGER_TEST_SOURCES
  surface_manager_test.cpp
  ${CMAKE_SOURCE_DIR}/src/common/debughelpers.cpp
)

include_directories(
  ${CMAKE_SOURCE_DIR}/src/common
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver/miroil/include
  ${CMAKE_SOURCE_DIR}/src/modules
  ${CMAKE_SOURCE_DIR}/tests/framework
)

include_directories(
  SYSTEM
  ${APPLICATION_API_INCLUDE_DIRS}
  ${MIRTEST_INCLUDE_DIRS}
)

add_executable(surfacemanager_test ${SURFACE_MANAGER_TEST_SOURCES})

add_dependencies(surfacemanager_test qtmir-test-framework-static)

target_link_libraries(
  surfacemanager_test

  qtmirapplicationplugin

  Qt5::Test

  -L${CMAKE_BINARY_DIR}/tests/framework
  qtmir-test-framework-static

  ${MIRTEST_LDFLAGS}
  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARIES}
)

add_test(SurfaceManager, surfacemanager_test)

=== src/platforms/mirserver/wayland-generated/CMakeLists.txt ===
function(add_wayland_protocol PREFIX PROTOCOL)
    set(PROTOCOL_FILE "${CMAKE_CURRENT_SOURCE_DIR}/../wayland-protocols/${PROTOCOL}.xml")

    set(GENERATE_FILE "${CMAKE_CURRENT_SOURCE_DIR}/${PROTOCOL}_wrapper")

    add_custom_command(
        OUTPUT ${GENERATE_FILE}.cpp
        OUTPUT ${GENERATE_FILE}.h
        DEPENDS ${PROTOCOL_FILE}
        COMMAND "sh" "-c" "/usr/bin/mir_wayland_generator ${PREFIX} ${PROTOCOL_FILE} header >${GENERATE_FILE}.h"
        COMMAND "sh" "-c" "/usr/bin/mir_wayland_generator ${PREFIX} ${PROTOCOL_FILE} source >${GENERATE_FILE}.cpp"
    )

    set(GENERATED_FILES ${GENERATED_FILES} "${GENERATE_FILE}.h" "${GENERATE_FILE}.cpp" PARENT_SCOPE)
endfunction()

add_wayland_protocol("qt_" "qt-windowmanager")
add_wayland_protocol("z" "xdg-decoration-unstable-v1")
add_wayland_protocol("org_kde_" "server-decoration")

add_custom_target(refresh-wayland-wrapper
    DEPENDS ${GENERATED_FILES}
    SOURCES ${GENERATED_FILES}
)

=== debian/changelog ===
qtmir (0.8.0~git20240131.2f99df3-1build5) noble; urgency=medium

  * No-change rebuild against Qt 5.15.13.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Wed, 03 Apr 2024 10:57:20 +0300

qtmir (0.8.0~git20240131.2f99df3-1build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:52:07 +1100

qtmir (0.8.0~git20240131.2f99df3-1build3) noble; urgency=medium

  * No-change rebuild against mir t64.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 21 Mar 2024 22:39:45 +0100

qtmir (0.8.0~git20240131.2f99df3-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:51:32 +0000

qtmir (0.8.0~git20240131.2f99df3-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 06:47:26 +0000

qtmir (0.8.0~git20240131.2f99df3-1) unstable; urgency=medium

  * New git snapshot
  * debian/patches: Drop upstreamed patches
    - 1001_copyright-header-cleanup.patch
    - 1002_maliit-keyboard.patch
    - 1003_require-miroil-in-pkgconfig-file.patch

 -- Marius Gripsgard <mariogrip@debian.org>  Wed, 31 Jan 2024 13:25:09 +0100

qtmir (0.8.0~git20240108.ae0d874-1) unstable; urgency=medium

  [ Marius Gripsgard ]
  * New git snapshot
  * debian/patches:
    + Refresh patches.

  [ Mike Gabriel ]
  * debian/patches:
    + Forward patches needed by upstream.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * debian/control:
    + Bump Standards-Version: to 4.6.2. No changes needed.
    + Switch from libfontconfig-dev to libfontconfig1-dev.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 16 Jan 2024 14:11:44 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: qtmir
 Section: libs
 Priority: optional
-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>,
  Mike Gabriel <sunweaver@debian.org>,
@@ -10,7 +11,7 @@
                cmake-extras (>= 1.6~),
                debhelper-compat (= 13),
                googletest (>= 1.10.0),
-               libfontconfig1-dev,
+               libfontconfig-dev,
                libgles2-mesa-dev,
                libglib2.0-dev,
                libgsettings-qt-dev,
@@ -49,7 +50,7 @@
 # mirtest pkgconfig requires these, but doesn't have a deb dependency. Bug lp:1633537
                libboost-filesystem-dev,
                libboost-system-dev,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/core/qtmir
 Vcs-Git: https://salsa.debian.org/ubports-team/qtmir.git

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none,  pretty=0.8.0~git%cd.%h" \
https://gitlab.com/ubports/development/core/qtmir.git \
heads/personal/mariogrip/desktop-development debian uupdate

## qtmir 0.8.0~git20240306.de639c3

=== tests/modules/SharedWakelock/CMakeLists.txt ===
set(
  SHARED_WAKELOCK_TEST_SOURCES
  sharedwakelock_test.cpp
)

include_directories(
  ${CMAKE_SOURCE_DIR}/src/modules
)

include_directories(
  SYSTEM
  ${QTDBUSTEST_INCLUDE_DIRS}
  ${QTDBUSMOCK_INCLUDE_DIRS}
)

add_executable(sharedwakelock_test ${SHARED_WAKELOCK_TEST_SOURCES})

target_link_libraries(
  sharedwakelock_test

  qtmirapplicationplugin

  Qt5::Test

  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARIES}
  ${QTDBUSTEST_LIBRARIES}
  ${QTDBUSMOCK_LIBRARIES}
)

add_test(SharedWakelock, sharedwakelock_test)

=== debian/changelog ===
qtmir (0.8.0~git20240306.de639c3-1build1) oracular; urgency=medium

  * No-change rebuild against Qt 5.15.15.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Fri, 13 Sep 2024 12:12:08 +0300

qtmir (0.8.0~git20240306.de639c3-1) unstable; urgency=medium

  * New git snapshot.
  * debian/watch:
    + Obtain Git snapshot from upstream branch /personal/sunweaver/debian-
      upstream.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 08 Mar 2024 08:16:51 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: qtmir
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>,
  Mike Gabriel <sunweaver@debian.org>,

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none,  pretty=0.8.0~git%cd.%h" \
https://gitlab.com/ubports/development/core/qtmir.git \
heads/personal/sunweaver/debian-upstream debian uupdate
